--==============================================================
-- Database name:  PHYSICALDATAMODEL_2
-- DBMS name:      IBM DB2 UDB 7.x Common Server
-- Created on:     12.04.2004 13:46:43
--==============================================================


drop table T_CATEGORY;

drop table T_CONFIGURATION;

drop table T_PROPERTY;

drop table T_VARIABLE;

--==============================================================
-- Table: T_CATEGORY
--==============================================================
create table T_CATEGORY
(
   OID                  NUMERIC(6)             not null generated by default as identity,
   "NAME"               VARCHAR(255),
   CONFIGURATION_OID    INTEGER,
   constraint P_KEY_1 primary key (OID)
);

--==============================================================
-- Table: T_CONFIGURATION
--==============================================================
create table T_CONFIGURATION
(
   OID                  NUMERIC(6)             not null generated by default as identity,
   "NAME"               VARCHAR(255)           not null,
   constraint P_KEY_1 primary key (OID),
   constraint A_KEY_2 unique ("NAME")
);

--==============================================================
-- Table: T_PROPERTY
--==============================================================
create table T_PROPERTY
(
   OID                  NUMERIC(6)             not null generated by default as identity,
   "NAME"               VARCHAR(255),
   VALUE                VARCHAR(255),
   CATEGORY_OID         INTEGER                not null,
   constraint P_KEY_1 primary key (OID)
);

--==============================================================
-- Table: T_VARIABLE
--==============================================================
create table T_VARIABLE
(
   OID                  NUMERIC(6)             not null generated by default as identity,
   "NAME"               VARCHAR(255),
   VALUE                VARCHAR(255),
   CONFIGURATION_OID    INTEGER,
   constraint P_KEY_1 primary key (OID)
);

alter table T_CATEGORY
   add constraint F_CAT_CON_REF foreign key (CONFIGURATION_OID)
      references T_CONFIGURATION (OID)
      on delete restrict on update restrict;

alter table T_PROPERTY
   add constraint F_PRO_CAT_REF foreign key (CATEGORY_OID)
      references T_CATEGORY (OID)
      on delete restrict on update restrict;

alter table T_VARIABLE
   add constraint F_VAR_CON_REF foreign key (CONFIGURATION_OID)
      references T_CONFIGURATION (OID)
      on delete restrict on update restrict;

